// Copyright (C) 2010 - H. Nahrstaedt
//

computed = nan_conv (ones (3, 1), ones (3, 1));
expected = [1; 2; 3; 2; 1];
assert_checkalmostequal ( computed , expected , %eps );

computed = nan_conv (ones (1, 3), ones (3, 1));
expected = [1, 2, 3, 2, 1];
assert_checkalmostequal ( computed , expected , %eps );

computed = nan_conv (3, [1, 2, 3]);
expected = [3, 6, 9];
assert_checkalmostequal ( computed , expected , %eps );


computed = nan_conv (2, 3);
expected = 6;
assert_checkalmostequal ( computed , expected , %eps );

computed =  nan_conv([1   2   3   4],[10   20   30]);
expected =  [10     40     100     160     170     120];
assert_checkalmostequal ( computed , expected , %eps );

 a = 1:10;
 b = 1:3;
 c = nan_conv (a, b);

computed = size(c);
expected = [1, length(a)+length(b)-1];
assert_checkalmostequal ( computed , expected , %eps );

a = (1:10).';
b = 1:3;
c = nan_conv (a, b);

computed = size(c);
expected = [length(a)+length(b)-1, 1];
assert_checkalmostequal ( computed , expected , %eps );

a = 1:10;
b = (1:3).';
c = nan_conv (a, b);
computed = size(c);
expected = [1, length(a)+length(b)-1];
assert_checkalmostequal ( computed , expected , %eps );


b = 1:10;
a = 1:3;
c = nan_conv (a, b);
computed = size(c);
expected = [1, length(a)+length(b)-1];
assert_checkalmostequal ( computed , expected , %eps );

b = (1:10).';
a = 1:3;
c = nan_conv (a, b);
computed = size(c);
expected = [length(a)+length(b)-1, 1];
assert_checkalmostequal ( computed , expected , %eps );


b = 1:10;
a = (1:3).';
c = nan_conv (a, b);
computed = size(c);
expected = [1, length(a)+length(b)-1];
assert_checkalmostequal ( computed , expected , %eps );


//error conv ([1, 2; 3, 4], 3);


//error conv (2, []);


